/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/shader/shaderbuffer.h"
#include "display/tilesetgl.h"

#define TILESET_BLOCK_NAME "b_Tileset"
#define TILESET_UNIFORM_TEXTURES_NAME "u_TilesetTextures"

typedef struct {
  int32_t columns;
  int32_t rows;
  int32_t width;
  int32_t height;
} tilesetshaderdatatileset_t;

typedef struct {
  tilesetshaderdatatileset_t tilesets[TILESET_COUNT];
} tilesetshaderdata_t;

extern shaderbuffer_t TILESET_SHADER_DATA_BUFFER;
extern tilesetshaderdata_t TILESET_SHADER_DATA_DATA;

/**
 * Initializes the tileset buffer and data.
 */
void tilesetShaderDataInit();

/**
 * Updates the tileset buffer with the current data.
 */
void tilesetShaderDataUpdate();

/**
 * Destroys the tileset buffer.
 */
void tilesetShaderDataDispose();